"""
    Vorlesungsbeispiel
    Rekursive Funktion, die Bäume zeichnet
    Author: M. Esponda
    ALP2 SS 2012
"""

import math
from ps_functions import *


def paint_tree(filename, recursion_depth, shrink, angle):
    """
       Bei Eingabe der Rekursionstiefe (recursion_depth),
                       Verkleinerungsfaktor (shrink) für die neuen Zweige
                       und Winkel (angle) zwischen den Zweigen
       wird ein postscript-Programm in die Datei (filename) geschrieben,
       das einen Baum zeichnet.
    """
    begin(filename+".ps", 500, 500)
    tree_branch(recursion_depth, 200, 50, 0, 1, 150, shrink, angle)    
    end()

def tree_branch(rec_depth, x, y, dir_x, dir_y, size, shrink, angle):

    new_x = x + size*dir_x
    new_y = y + size*dir_y
    
    drawLine(x, y, new_x, new_y)

    if rec_depth < 0:
        return
    
    new_size = size / shrink
    
    rec_depth -= 1
    
    left_dir_x = math.cos(angle)*dir_x + math.sin(angle)*dir_y
    left_dir_y = -math.sin(angle)*dir_x + math.cos(angle)*dir_y
    
    tree_branch(rec_depth, new_x, new_y, left_dir_x, left_dir_y, new_size, shrink, angle)

    right_dir_x = math.cos(-angle)*dir_x + math.sin(-angle)*dir_y
    right_dir_y = -math.sin(-angle)*dir_x + math.cos(-angle)*dir_y

    tree_branch(rec_depth, new_x, new_y, right_dir_x, right_dir_y, new_size, shrink, angle)
    

def test_paint_tree():
    paint_tree("primer_tree", 9, 1.9, math.pi/5)
    paint_tree("segundo_tree", 9, 1.9, math.pi/3)
    paint_tree("sexto_tree", 9, 1.9, math.pi/2)
    paint_tree("tercero_tree", 9, 1.9, math.pi/4)
    paint_tree("cuarto_tree", 9, 1.9, math.pi/6)
    paint_tree("quinto_tree", 9, 1.9, math.pi/8)

test_paint_tree()

